Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D


Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim testo As Font
    Dim stanza As oggX
    Dim quadrato(5) As Vertex
    Dim t1 As Texture
    Dim t2 As Texture

    Dim angolo As Single
    Dim distanza As Single
    Dim h As Single

    Dim vEye As Vector3

#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(626, 448)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "BillBoarding"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        creaSchermo(0, 0, 0, Me.Handle, True)
        iniziatutto()
        Me.Show()
        Me.Focus()

        testo = creaFont(New Drawing.Font("Arial", 12))
        stanza = creaMesh(AppPath() & "\monte.x", True, True, AppPath)

        quadrato(0) = CreaD3Dv(-1, 0, 0, 0, 0, 0, 0, 1)
        quadrato(1) = CreaD3Dv(-1, 2, 0, 0, 0, 0, 0, 0)
        quadrato(2) = CreaD3Dv(1, 2, 0, 0, 0, 0, 1, 0)
        quadrato(3) = CreaD3Dv(1, 2, 0, 0, 0, 0, 1, 0)
        quadrato(4) = CreaD3Dv(1, -0, 0, 0, 0, 0, 1, 1)
        quadrato(5) = CreaD3Dv(-1, 0, 0, 0, 0, 0, 0, 1)


        t1 = creaTexture(AppPath() & "\alberoI.bmp", 0)
        t2 = creaTexture(AppPath() & "\albero.bmp", Color.Black.ToArgb)

        distanza = 80
        h = 40


        mainLoop()
    End Sub

    Sub mainLoop()
        Dim r As New Rectangle(0, 0, 500, 600)
        'renderizza sulle facce della texture cubica

        Dim i As Integer

        Do
            angolo = (angolo + 0.1)
            vEye = New Vector3(Math.Sin(angolo * rad) * distanza, h, Math.Cos(angolo * rad) * distanza)
            device.Transform.View = Matrix.LookAtLH(vEye, New Vector3(0, 0, 0), New Vector3(0, 1, 0))

            Application.DoEvents()
            device.Clear(ClearFlags.Target Or ClearFlags.ZBuffer, Color.Blue, 1, 0)
            device.BeginScene()

            muoviObj(1, 1, 1, 0, 0, 0, 0, -40, 0)
            For i = 0 To stanza.numX
                device.SetTexture(0, stanza.tex(i))
                device.SetTexture(1, Nothing)
                device.Material = stanza.mat(i)
                stanza.mesh.DrawSubset(i)
            Next

            device.RenderState.AlphaBlendEnable = True
            device.RenderState.SourceBlend = Blend.SourceAlpha
            device.RenderState.DestinationBlend = Blend.InvSourceAlpha

            device.TextureState(1).ColorOperation = TextureOperation.Modulate
            device.TextureState(1).ColorArgument1 = TextureArgument.TextureColor
            device.TextureState(1).ColorArgument2 = TextureArgument.Current


            device.SetTexture(1, t1)
            device.SetTexture(0, t2)
            device.TextureState(1).TextureCoordinateIndex = 0


            Dim angoloR As Single

            'alberi

            angoloR = getAngolo(New Vector3(60, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 60, -22, 0)
            device.VertexFormat = CustomVertex.PositionNormalTextured.Format
            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(-60, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, -60, -22, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(0, -10, 60), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -22, 60)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(0, -10, -60), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -22, -60)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(40, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 40, -18, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(-40, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, -40, -18, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(0, -10, 40), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -18, 40)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(0, -10, -40), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -18, -40)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(20, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 20, -12, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)


            angoloR = getAngolo(New Vector3(-20, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, -20, -12, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            angoloR = getAngolo(New Vector3(0, -10, 20), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -12, 20)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)


            angoloR = getAngolo(New Vector3(0, -10, -20), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -12, -20)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)


            angoloR = getAngolo(New Vector3(0, -10, 0), vEye)
            muoviObj(5, 5, 5, 0, angoloR + 180, 0, 0, -10, 0)

            device.DrawUserPrimitives(PrimitiveType.TriangleList, 2, quadrato)

            '28,27,24


            device.RenderState.AlphaBlendEnable = False
            device.TextureState(1).ColorOperation = TextureOperation.Disable


            'testo
            testo.DrawText(Nothing, "Esempio di BillBoarding. Premi su e gi e A e Z per modificare la distanza e l'altezza della telecamera", 0, 0, Color.White)

            device.EndScene()
            device.Present()

        Loop
    End Sub


    Function getAngolo(ByVal o As Vector3, ByVal c As Vector3) As Single
        Dim ax As Single
        Dim ay As Single
        ax = c.X - o.X
        ay = c.Z - o.Z

        If ay < 0 Then
            getAngolo = Math.Atan(ax / ay) / rad + 180
        End If

        If ay > 0 Then
            If ax > 0 Then
                getAngolo = Math.Atan(ax / ay) / rad
            Else
                getAngolo = 360 + Math.Atan(ax / ay) / rad
            End If
        End If

        If ay = 0 Then
            If ax > 0 Then getAngolo = 0 Else getAngolo = 180
        End If

    End Function

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        device.Dispose()
        End
    End Sub

    Private Function CreaD3Dv(ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal nx As Single, ByVal ny As Single, ByVal nz As Single, ByVal tu As Single, ByVal tv As Single) As Vertex
        Dim v As Vertex
        v.p = New Vector3(x, y, z)
        v.n = New Vector3(nx, ny, nz)
        v.tu = tu
        v.tv = tv
        Return v
    End Function

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Up
                distanza = distanza - 5
            Case Keys.Down
                distanza = distanza + 5
            Case Keys.A
                h = h - 5
            Case Keys.Z
                h = h + 5
        End Select
    End Sub
End Class
